/*
 * File:    armour.h
 * Author:  Holger Klawitter
 */

typedef struct {
  UInt8 valid_bits; /* number of valid bits in carry */
  UInt16 a; /* accumulator */
  Boolean higapped; /* true if armoured text does not use 0x80 - 0x9F */
  Char *destPtr;
} armour_globals_t;

/*
 * Transfoming a character sequence (with possible Zeros inside into
 * an ASCII Sequence.
 *
 * src - Char sequence to be transformed
 * n   - Number of valid characters in src. StrLen would not work.
 *
 * returns a new string with just the right size.
 */
static Char *armour(UInt8 *src, Int16 n, armour_globals_t *ag);

/*
 * Generates a sequence of bytes (wkith possible Zeros inside).
 *
 * src - The Ascii sequence to generate the sequence from.
 *
 * returns a new byte sequence.
 * The length of the sequence is being written into *len
 */
static UInt8 *deArmour(Char* src, Int16* len, armour_globals_t *ag);

static armour_globals_t *InitArmourGlobals(void);
static void FreeArmourGlobals(armour_globals_t *ag);

// EOF
